/**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#ifndef OAI_OAIKnowledgeApi_H
#define OAI_OAIKnowledgeApi_H

#include "OAIHelpers.h"
#include "OAIHttpRequest.h"
#include "OAIServerConfiguration.h"
#include "OAIOauth.h"

#include "OAIRandomQuoteAPI_200_response.h"
#include "OAIRandomRiddleAPI_200_response.h"
#include "OAIRandomTriviaAPI_200_response.h"
#include <QString>

#include <QObject>
#include <QByteArray>
#include <QStringList>
#include <QList>
#include <QNetworkAccessManager>

namespace OpenAPI {

class OAIKnowledgeApi : public QObject {
    Q_OBJECT

public:
    OAIKnowledgeApi(const int timeOut = 0);
    ~OAIKnowledgeApi();

    void initializeServerConfigs();
    int setDefaultServerValue(int serverIndex,const QString &operation, const QString &variable,const QString &val);
    void setServerIndex(const QString &operation, int serverIndex);
    void setApiKey(const QString &apiKeyName, const QString &apiKey);
    void setBearerToken(const QString &token);
    void setUsername(const QString &username);
    void setPassword(const QString &password);
    void setTimeOut(const int timeOut);
    void setWorkingDirectory(const QString &path);
    void setNetworkAccessManager(QNetworkAccessManager* manager);
    int addServerConfiguration(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables = QMap<QString, OAIServerVariable>());
    void setNewServerForAllOperations(const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void setNewServer(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void addHeaders(const QString &key, const QString &value);
    void enableRequestCompression();
    void enableResponseCompression();
    void abortRequests();
    QString getParamStylePrefix(const QString &style);
    QString getParamStyleSuffix(const QString &style);
    QString getParamStyleDelimiter(const QString &style, const QString &name, bool isExplode);

    /**
    * @param[in]  min_length qint32 [optional]
    * @param[in]  max_length qint32 [optional]
    */
    void randomQuoteAPI(const ::OpenAPI::OptionalParam<qint32> &min_length = ::OpenAPI::OptionalParam<qint32>(), const ::OpenAPI::OptionalParam<qint32> &max_length = ::OpenAPI::OptionalParam<qint32>());

    /**
    * @param[in]  difficulty QString [optional]
    */
    void randomRiddleAPI(const ::OpenAPI::OptionalParam<QString> &difficulty = ::OpenAPI::OptionalParam<QString>());

    /**
    * @param[in]  max_length qint32 [optional]
    */
    void randomTriviaAPI(const ::OpenAPI::OptionalParam<qint32> &max_length = ::OpenAPI::OptionalParam<qint32>());


private:
    QMap<QString,int> _serverIndices;
    QMap<QString,QList<OAIServerConfiguration>> _serverConfigs;
    QMap<QString, QString> _apiKeys;
    QString _bearerToken;
    QString _username;
    QString _password;
    int _timeOut;
    QString _workingDirectory;
    QNetworkAccessManager* _manager;
    QMap<QString, QString> _defaultHeaders;
    bool _isResponseCompressionEnabled;
    bool _isRequestCompressionEnabled;
    OAIHttpRequestInput _latestInput;
    OAIHttpRequestWorker *_latestWorker;
    QStringList _latestScope;
    OauthCode _authFlow;
    OauthImplicit _implicitFlow;
    OauthCredentials _credentialFlow;
    OauthPassword _passwordFlow;
    int _OauthMethod = 0;

    void randomQuoteAPICallback(OAIHttpRequestWorker *worker);
    void randomRiddleAPICallback(OAIHttpRequestWorker *worker);
    void randomTriviaAPICallback(OAIHttpRequestWorker *worker);

Q_SIGNALS:

    void randomQuoteAPISignal(OAIRandomQuoteAPI_200_response summary);
    void randomRiddleAPISignal(OAIRandomRiddleAPI_200_response summary);
    void randomTriviaAPISignal(OAIRandomTriviaAPI_200_response summary);

    void randomQuoteAPISignalFull(OAIHttpRequestWorker *worker, OAIRandomQuoteAPI_200_response summary);
    void randomRiddleAPISignalFull(OAIHttpRequestWorker *worker, OAIRandomRiddleAPI_200_response summary);
    void randomTriviaAPISignalFull(OAIHttpRequestWorker *worker, OAIRandomTriviaAPI_200_response summary);

    Q_DECL_DEPRECATED_X("Use randomQuoteAPISignalError() instead")
    void randomQuoteAPISignalE(OAIRandomQuoteAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void randomQuoteAPISignalError(OAIRandomQuoteAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use randomRiddleAPISignalError() instead")
    void randomRiddleAPISignalE(OAIRandomRiddleAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void randomRiddleAPISignalError(OAIRandomRiddleAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use randomTriviaAPISignalError() instead")
    void randomTriviaAPISignalE(OAIRandomTriviaAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void randomTriviaAPISignalError(OAIRandomTriviaAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);

    Q_DECL_DEPRECATED_X("Use randomQuoteAPISignalErrorFull() instead")
    void randomQuoteAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void randomQuoteAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use randomRiddleAPISignalErrorFull() instead")
    void randomRiddleAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void randomRiddleAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use randomTriviaAPISignalErrorFull() instead")
    void randomTriviaAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void randomTriviaAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);

    void abortRequestsSignal();
    void allPendingRequestsCompleted();

public Q_SLOTS:
    void tokenAvailable();
};

} // namespace OpenAPI
#endif
