/**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#ifndef OAI_OAIMediaApi_H
#define OAI_OAIMediaApi_H

#include "OAIHelpers.h"
#include "OAIHttpRequest.h"
#include "OAIServerConfiguration.h"
#include "OAIOauth.h"

#include "OAIDetectMainImageColorAPI_200_response_inner.h"
#include "OAIHttpFileElement.h"
#include "OAISearchIconsAPI_200_response.h"
#include "OAISearchRoyaltyFreeImagesAPI_200_response.h"
#include "OAIVectorSearchAPI_200_response.h"
#include <QString>

#include <QObject>
#include <QByteArray>
#include <QStringList>
#include <QList>
#include <QNetworkAccessManager>

namespace OpenAPI {

class OAIMediaApi : public QObject {
    Q_OBJECT

public:
    OAIMediaApi(const int timeOut = 0);
    ~OAIMediaApi();

    void initializeServerConfigs();
    int setDefaultServerValue(int serverIndex,const QString &operation, const QString &variable,const QString &val);
    void setServerIndex(const QString &operation, int serverIndex);
    void setApiKey(const QString &apiKeyName, const QString &apiKey);
    void setBearerToken(const QString &token);
    void setUsername(const QString &username);
    void setPassword(const QString &password);
    void setTimeOut(const int timeOut);
    void setWorkingDirectory(const QString &path);
    void setNetworkAccessManager(QNetworkAccessManager* manager);
    int addServerConfiguration(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables = QMap<QString, OAIServerVariable>());
    void setNewServerForAllOperations(const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void setNewServer(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void addHeaders(const QString &key, const QString &value);
    void enableRequestCompression();
    void enableResponseCompression();
    void abortRequests();
    QString getParamStylePrefix(const QString &style);
    QString getParamStyleSuffix(const QString &style);
    QString getParamStyleDelimiter(const QString &style, const QString &name, bool isExplode);

    /**
    * @param[in]  url QString [required]
    */
    void detectMainImageColorAPI(const QString &url);

    /**
    * @param[in]  url QString [required]
    * @param[in]  width qint32 [required]
    * @param[in]  height qint32 [required]
    * @param[in]  crop bool [required]
    */
    void rescaleImageAPI(const QString &url, const qint32 &width, const qint32 &height, const bool &crop);

    /**
    * @param[in]  query QString [required]
    * @param[in]  only_public_domain bool [optional]
    * @param[in]  number qint32 [optional]
    */
    void searchIconsAPI(const QString &query, const ::OpenAPI::OptionalParam<bool> &only_public_domain = ::OpenAPI::OptionalParam<bool>(), const ::OpenAPI::OptionalParam<qint32> &number = ::OpenAPI::OptionalParam<qint32>());

    /**
    * @param[in]  query QString [required]
    * @param[in]  number qint32 [optional]
    */
    void searchRoyaltyFreeImagesAPI(const QString &query, const ::OpenAPI::OptionalParam<qint32> &number = ::OpenAPI::OptionalParam<qint32>());

    /**
    * @param[in]  query QString [required]
    * @param[in]  offset qint32 [optional]
    * @param[in]  number qint32 [optional]
    */
    void vectorSearchAPI(const QString &query, const ::OpenAPI::OptionalParam<qint32> &offset = ::OpenAPI::OptionalParam<qint32>(), const ::OpenAPI::OptionalParam<qint32> &number = ::OpenAPI::OptionalParam<qint32>());


private:
    QMap<QString,int> _serverIndices;
    QMap<QString,QList<OAIServerConfiguration>> _serverConfigs;
    QMap<QString, QString> _apiKeys;
    QString _bearerToken;
    QString _username;
    QString _password;
    int _timeOut;
    QString _workingDirectory;
    QNetworkAccessManager* _manager;
    QMap<QString, QString> _defaultHeaders;
    bool _isResponseCompressionEnabled;
    bool _isRequestCompressionEnabled;
    OAIHttpRequestInput _latestInput;
    OAIHttpRequestWorker *_latestWorker;
    QStringList _latestScope;
    OauthCode _authFlow;
    OauthImplicit _implicitFlow;
    OauthCredentials _credentialFlow;
    OauthPassword _passwordFlow;
    int _OauthMethod = 0;

    void detectMainImageColorAPICallback(OAIHttpRequestWorker *worker);
    void rescaleImageAPICallback(OAIHttpRequestWorker *worker);
    void searchIconsAPICallback(OAIHttpRequestWorker *worker);
    void searchRoyaltyFreeImagesAPICallback(OAIHttpRequestWorker *worker);
    void vectorSearchAPICallback(OAIHttpRequestWorker *worker);

Q_SIGNALS:

    void detectMainImageColorAPISignal(QList<OAIDetectMainImageColorAPI_200_response_inner> summary);
    void rescaleImageAPISignal(OAIHttpFileElement summary);
    void searchIconsAPISignal(OAISearchIconsAPI_200_response summary);
    void searchRoyaltyFreeImagesAPISignal(OAISearchRoyaltyFreeImagesAPI_200_response summary);
    void vectorSearchAPISignal(OAIVectorSearchAPI_200_response summary);

    void detectMainImageColorAPISignalFull(OAIHttpRequestWorker *worker, QList<OAIDetectMainImageColorAPI_200_response_inner> summary);
    void rescaleImageAPISignalFull(OAIHttpRequestWorker *worker, OAIHttpFileElement summary);
    void searchIconsAPISignalFull(OAIHttpRequestWorker *worker, OAISearchIconsAPI_200_response summary);
    void searchRoyaltyFreeImagesAPISignalFull(OAIHttpRequestWorker *worker, OAISearchRoyaltyFreeImagesAPI_200_response summary);
    void vectorSearchAPISignalFull(OAIHttpRequestWorker *worker, OAIVectorSearchAPI_200_response summary);

    Q_DECL_DEPRECATED_X("Use detectMainImageColorAPISignalError() instead")
    void detectMainImageColorAPISignalE(QList<OAIDetectMainImageColorAPI_200_response_inner> summary, QNetworkReply::NetworkError error_type, QString error_str);
    void detectMainImageColorAPISignalError(QList<OAIDetectMainImageColorAPI_200_response_inner> summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use rescaleImageAPISignalError() instead")
    void rescaleImageAPISignalE(OAIHttpFileElement summary, QNetworkReply::NetworkError error_type, QString error_str);
    void rescaleImageAPISignalError(OAIHttpFileElement summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use searchIconsAPISignalError() instead")
    void searchIconsAPISignalE(OAISearchIconsAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void searchIconsAPISignalError(OAISearchIconsAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use searchRoyaltyFreeImagesAPISignalError() instead")
    void searchRoyaltyFreeImagesAPISignalE(OAISearchRoyaltyFreeImagesAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void searchRoyaltyFreeImagesAPISignalError(OAISearchRoyaltyFreeImagesAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use vectorSearchAPISignalError() instead")
    void vectorSearchAPISignalE(OAIVectorSearchAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void vectorSearchAPISignalError(OAIVectorSearchAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);

    Q_DECL_DEPRECATED_X("Use detectMainImageColorAPISignalErrorFull() instead")
    void detectMainImageColorAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void detectMainImageColorAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use rescaleImageAPISignalErrorFull() instead")
    void rescaleImageAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void rescaleImageAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use searchIconsAPISignalErrorFull() instead")
    void searchIconsAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void searchIconsAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use searchRoyaltyFreeImagesAPISignalErrorFull() instead")
    void searchRoyaltyFreeImagesAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void searchRoyaltyFreeImagesAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use vectorSearchAPISignalErrorFull() instead")
    void vectorSearchAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void vectorSearchAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);

    void abortRequestsSignal();
    void allPendingRequestsCompleted();

public Q_SLOTS:
    void tokenAvailable();
};

} // namespace OpenAPI
#endif
