/**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#ifndef OAI_OAIStorageApi_H
#define OAI_OAIStorageApi_H

#include "OAIHelpers.h"
#include "OAIHttpRequest.h"
#include "OAIServerConfiguration.h"
#include "OAIOauth.h"

#include "OAIReadKeyValueFromStoreAPI_200_response.h"
#include "OAIStoreKeyValueGETAPI_200_response.h"
#include <QString>

#include <QObject>
#include <QByteArray>
#include <QStringList>
#include <QList>
#include <QNetworkAccessManager>

namespace OpenAPI {

class OAIStorageApi : public QObject {
    Q_OBJECT

public:
    OAIStorageApi(const int timeOut = 0);
    ~OAIStorageApi();

    void initializeServerConfigs();
    int setDefaultServerValue(int serverIndex,const QString &operation, const QString &variable,const QString &val);
    void setServerIndex(const QString &operation, int serverIndex);
    void setApiKey(const QString &apiKeyName, const QString &apiKey);
    void setBearerToken(const QString &token);
    void setUsername(const QString &username);
    void setPassword(const QString &password);
    void setTimeOut(const int timeOut);
    void setWorkingDirectory(const QString &path);
    void setNetworkAccessManager(QNetworkAccessManager* manager);
    int addServerConfiguration(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables = QMap<QString, OAIServerVariable>());
    void setNewServerForAllOperations(const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void setNewServer(const QString &operation, const QUrl &url, const QString &description = "", const QMap<QString, OAIServerVariable> &variables =  QMap<QString, OAIServerVariable>());
    void addHeaders(const QString &key, const QString &value);
    void enableRequestCompression();
    void enableResponseCompression();
    void abortRequests();
    QString getParamStylePrefix(const QString &style);
    QString getParamStyleSuffix(const QString &style);
    QString getParamStyleDelimiter(const QString &style, const QString &name, bool isExplode);

    /**
    * @param[in]  key QString [required]
    */
    void readKeyValueFromStoreAPI(const QString &key);

    /**
    * @param[in]  key QString [required]
    * @param[in]  value QString [required]
    */
    void storeKeyValueGETAPI(const QString &key, const QString &value);


private:
    QMap<QString,int> _serverIndices;
    QMap<QString,QList<OAIServerConfiguration>> _serverConfigs;
    QMap<QString, QString> _apiKeys;
    QString _bearerToken;
    QString _username;
    QString _password;
    int _timeOut;
    QString _workingDirectory;
    QNetworkAccessManager* _manager;
    QMap<QString, QString> _defaultHeaders;
    bool _isResponseCompressionEnabled;
    bool _isRequestCompressionEnabled;
    OAIHttpRequestInput _latestInput;
    OAIHttpRequestWorker *_latestWorker;
    QStringList _latestScope;
    OauthCode _authFlow;
    OauthImplicit _implicitFlow;
    OauthCredentials _credentialFlow;
    OauthPassword _passwordFlow;
    int _OauthMethod = 0;

    void readKeyValueFromStoreAPICallback(OAIHttpRequestWorker *worker);
    void storeKeyValueGETAPICallback(OAIHttpRequestWorker *worker);

Q_SIGNALS:

    void readKeyValueFromStoreAPISignal(OAIReadKeyValueFromStoreAPI_200_response summary);
    void storeKeyValueGETAPISignal(OAIStoreKeyValueGETAPI_200_response summary);

    void readKeyValueFromStoreAPISignalFull(OAIHttpRequestWorker *worker, OAIReadKeyValueFromStoreAPI_200_response summary);
    void storeKeyValueGETAPISignalFull(OAIHttpRequestWorker *worker, OAIStoreKeyValueGETAPI_200_response summary);

    Q_DECL_DEPRECATED_X("Use readKeyValueFromStoreAPISignalError() instead")
    void readKeyValueFromStoreAPISignalE(OAIReadKeyValueFromStoreAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void readKeyValueFromStoreAPISignalError(OAIReadKeyValueFromStoreAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use storeKeyValueGETAPISignalError() instead")
    void storeKeyValueGETAPISignalE(OAIStoreKeyValueGETAPI_200_response summary, QNetworkReply::NetworkError error_type, QString error_str);
    void storeKeyValueGETAPISignalError(OAIStoreKeyValueGETAPI_200_response summary, QNetworkReply::NetworkError error_type, const QString &error_str);

    Q_DECL_DEPRECATED_X("Use readKeyValueFromStoreAPISignalErrorFull() instead")
    void readKeyValueFromStoreAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void readKeyValueFromStoreAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);
    Q_DECL_DEPRECATED_X("Use storeKeyValueGETAPISignalErrorFull() instead")
    void storeKeyValueGETAPISignalEFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, QString error_str);
    void storeKeyValueGETAPISignalErrorFull(OAIHttpRequestWorker *worker, QNetworkReply::NetworkError error_type, const QString &error_str);

    void abortRequestsSignal();
    void allPendingRequestsCompleted();

public Q_SLOTS:
    void tokenAvailable();
};

} // namespace OpenAPI
#endif
